SystemOrganization addCategory: #JSExtensions!

JSStatement subclass: #JSImmediatelyAfter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JSExtensions'!

!JSImmediatelyAfter methodsFor: 'public' stamp: 'sebastian.sastre 1/17/2010 20:25'!
javascriptContentOn: aStream
	super javascriptContentOn: aStream.
	aStream javascript: self statement
	! !

JSStatement subclass: #JSImmediatelyBefore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JSExtensions'!

!JSImmediatelyBefore methodsFor: 'printing' stamp: 'sebastian.sastre 1/17/2010 20:25'!
javascriptContentOn: aStream
	aStream javascript: self statement.
	super javascriptContentOn: aStream! !

JSStatement subclass: #JSWhile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JSExtensions'!

!JSWhile methodsFor: 'printing' stamp: 'sebastian.sastre 1/17/2010 18:59'!
javascriptContentOn: aStream

	aStream nextPutAll: 'while('.

	super javascriptContentOn: aStream.

	aStream 
		nextPutAll: '){';
		javascript: self statement;
		nextPut: $};
		yourself.

! !

!Association methodsFor: '*jsextensions' stamp: 'sebastian.sastre 8/5/2009 15:26'!
asJSHash
	^ JSHash new
		at: self key asJSObject
			put: self value;
		yourself! !

!JSAlias methodsFor: '*jsextensions' stamp: 'sebastian.sastre 1/17/2010 18:55'!
javascriptContentOn: aStream
	self name isString
		ifTrue:[aStream nextPutAll: self name]
		ifFalse:[aStream nextPutAll: self name displayString ]! !

!JSIfThenElse methodsFor: '*jsextensions' stamp: 'sebastian.sastre 1/17/2010 18:43'!
javascriptContentOn: aStream

	aStream nextPutAll: 'if('.

	super javascriptContentOn: aStream.

	aStream 
		nextPutAll: '){';
		javascript: self trueStatement;
		nextPut: $};
		yourself.

	self falseStatement ifNotNil:[
		aStream 
			nextPutAll: ' else {';
			javascript: self falseStatement;
			nextPut: $}]! !

!Number methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 19:11'!
asJSObject
	^ JSObject new alias: self asString! !

JSObject subclass: #JSHash
	instanceVariableNames: 'dictionary support'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JSExtensions'!

!JSHash methodsFor: 'accessing' stamp: 'sas 10/26/2008 18:29'!
at: aKey

	^ self support at: aKey ! !

!JSHash methodsFor: 'accessing' stamp: 'sebastian.sastre 7/20/2009 19:11'!
at: aKey put: anObject 
	^ self support 
		at: aKey asJSObject
		put: anObject! !

!JSHash methodsFor: 'public' stamp: 'sebastian.sastre 1/25/2010 11:55'!
each: anObject
	"The cornerstone of Enumerable. It lets you iterate over all the elements in a generic fashion, then returns the Enumerable, thereby allowing chain-calling."

	self call: 'each' with: (self iteratorFor: anObject return: false)! !

!JSHash methodsFor: 'initialization' stamp: 'sas 10/26/2008 18:29'!
initializeSupport
	^ support := Dictionary new! !

!JSHash methodsFor: 'accessing' stamp: 'sas 7/28/2008 21:03'!
iteratorFor: anObject return: aBoolean
	^ (anObject isKindOf: BlockClosure)
		ifFalse: [ anObject asFunction ]
		ifTrue: [ (JSFunction on: self canvas iterator: anObject) return: aBoolean ]! !

!JSHash methodsFor: 'printing' stamp: 'sebastian.sastre 1/17/2010 19:00'!
javascriptContentOn: aStream
	aStream 
		nextPutAll: self support asJavascript! !

!JSHash methodsFor: 'accessing' stamp: 'sas 10/26/2008 18:45'!
removeKey: aKey 
	
	^ self support at: aKey ! !

!JSHash methodsFor: 'accessing' stamp: 'sas 10/26/2008 18:29'!
support
	"Answer the value of the hash support"

	^ support ifNil:[self initializeSupport]! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:13'!
* anObject
	"Multiplies the receiver by anObject."
	
	^ self addDecoration: (JSBinary new operator: '*'; statement: anObject)! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:13'!
+ anObject
	"Adds the receiver to anObject."
	
	^ self addDecoration: (JSBinary new operator: '+'; statement: anObject)! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:14'!
- anObject
	"Subtracts anObject from the receiver."
	
	^ self addDecoration: (JSBinary new operator: '-'; statement: anObject)! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:14'!
/ anObject
	"Divides the receiver by anObject."
	
	^ self addDecoration: (JSBinary new operator: '/'; statement: anObject)! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:14'!
< anObject
	"Compares the receiver's element with anObject."
	
	^ self addDecoration: (JSBinary new operator: '<'; statement: anObject)! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:14'!
> anObject
	"Compares the receiver's element with anObject."
	
	^ self addDecoration: (JSBinary new operator: '>'; statement: anObject)! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:14'!
>= anObject
	"Compares the receiver's element with anObject."
	
	^ self addDecoration: (JSBinary new operator: '>='; statement: anObject)! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 8/5/2009 15:26'!
asJSHash
	^ JSHash on: self canvas! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 3/27/2010 16:16'!
asJSInfo
	^ JSLogger new info: self! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 19:13'!
asJSLog
	^ JSLogger new log: self! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 19:11'!
asJSObject
	^ self! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 8/5/2009 15:30'!
asJSString
	self call: 'asString'! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:24'!
assign: anObject as: aSelector

	^ (self access: aSelector) assign: anObject! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 1/25/2010 11:55'!
bind
	self 
		call: 'bind'
		with: 'this' asJSObject! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 1/25/2010 11:55'!
bind: anObject
	self call: 'bind' with: anObject! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastiansastre 8/25/2012 13:45'!
clearInterval: anArgument
	^ 'window' asJSObject call: 'clearInterval' with: anArgument ! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:24'!
dividedBy: anObject
	
	^ self / anObject ! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:24'!
ifFalse
	"Compares the receiver to false."
	
	^ self isEqualTo: false! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:24'!
ifTrue
	"Compares the receiver to true."
	
	^ self isEqualTo: true! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 1/17/2010 20:28'!
immediatelyAfter: anObject
	"Call anObject directly after the receiver code."
	
	^ self addDecoration: (JSImmediatelyAfter on: anObject)! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 1/17/2010 20:27'!
immediatelyBefore: anObject
	"Call anObject directly before the receiver code."
	
	^ self addDecoration: (JSImmediatelyBefore on: anObject)! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:25'!
interval: aDuration
	"Evaluates the receiver every aDuration."

	self addDecoration: (JSInterval duration: aDuration)! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:25'!
isEqualTo: anObject
	"Compares the receiver to anObject."
	
	^ self addDecoration: (JSBinary new operator: '=='; statement: anObject)! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:25'!
isNotEqualTo: anObject
	"Compares the receiver to anObject."
	
	^ self addDecoration: (JSBinary new operator: '!!='; statement: anObject)! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:25'!
isNull
	"Compares the receiver to null."
	
	^ self isEqualTo: nil! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastiansastre 7/14/2011 13:19'!
length

	^ self access: 'length'! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:25'!
multipliedBy: anObject
	"Multiplies the receiver by anObject."
	
	^ self * anObject ! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:25'!
notEqualTo: anObject
	"Compares the receiver to anObject."
	
	^ self addDecoration: (JSBinary new operator: '!!='; statement: anObject)! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:25'!
notNull
	"Compares the receiver to null."
	
	^ self notEqualTo: nil! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:25'!
parenthesized 
	"Return the receiver parenthesized"
	self 
		immediatelyBefore: (JSStream new nextPutAll: '(');
		immediatelyAfter: (JSStream new nextPutAll: ')');
		yourself
		
	

	! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:25'!
return
	"Return the receiver"
	self immediatelyBefore: (JSStream new nextPutAll: 'return ').
	

	! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 18:25'!
throw
	"Signals the receiver as exception"
	self immediatelyBefore: (JSStream new nextPutAll: 'throw ').
	

	! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 1/25/2010 11:55'!
toFixed: anInteger
	"If a number, makes the receiver to be printed with anInteger significant digits."
	
	self call: 'toFixed' with: anInteger! !

!JSObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 1/17/2010 18:59'!
whileTrueDo: anOperation
	"Evaluates anOperation repeatedly while if the receiver treated as a boolean evaluates to true."

	self addDecoration: (JSWhile new statement: anOperation)! !

!Dictionary methodsFor: '*jsextensions' stamp: 'sebastian.sastre 8/5/2009 15:26'!
asJSHash
	| hash |
	hash := JSHash new.
	self keysAndValuesDo: 
		[ :k :v | 
		hash 
			at: k asJSObject
			put: v ].
	^ hash! !

!JSLogger methodsFor: '*jsextensions' stamp: 'sas 1/5/2008 18:12'!
trace
	"Trace a couple of calls back in the firebug console."
	
	self call: 'trace'! !

!PTObject methodsFor: '*jsextensions' stamp: 'sebastian.sastre 1/17/2010 20:30'!
extend

	self addDecoration: PTExtend new! !

!UndefinedObject methodsFor: '*jsextensions' stamp: 'sas 10/27/2008 18:07'!
error: anObject

	^ self new
		error: anObject;
		yourself! !

!UndefinedObject methodsFor: '*jsextensions' stamp: 'sas 10/27/2008 18:07'!
info: anObject

	^ self new
		info: anObject;
		yourself! !

!UndefinedObject methodsFor: '*jsextensions' stamp: 'sas 10/27/2008 18:07'!
log: anObject

	^ self new
		log: anObject;
		yourself! !

!UndefinedObject methodsFor: '*jsextensions' stamp: 'sas 1/8/2008 20:47'!
trace

	^ self new 
		trace;
		yourself! !

!UndefinedObject methodsFor: '*jsextensions' stamp: 'sas 10/27/2008 18:07'!
warn: anObject

	^ self new
		warn: anObject;
		yourself! !

!JSAccess methodsFor: '*jsextensions' stamp: 'sebastian.sastre 1/17/2010 18:54'!
javascriptContentOn: aStream
	super javascriptContentOn: aStream.
	aStream nextPut: $.; nextPutAll: self name asString! !

!JSScript methodsFor: '*jsextensions' stamp: 'sebastian.sastre 4/5/2009 13:50'!
statements
	^ statements! !

!JSFunction methodsFor: '*jsextensions' stamp: 'sas 3/8/2008 0:19'!
addReturn
	super return! !

!JSFunction methodsFor: '*jsextensions' stamp: 'sas 12/11/2007 11:28'!
argument: anObject

	^ self arguments: (Array with: anObject)! !

!JSFunction methodsFor: '*jsextensions' stamp: 'sebastian.sastre 1/25/2010 11:54'!
bind: anObject

	^ self call: 'bind' with: anObject ! !

!JSFunction methodsFor: '*jsextensions' stamp: 'sas 3/8/2008 0:06'!
call

	^ self call: 'call' ! !

!JSFunction methodsFor: '*jsextensions' stamp: 'sas 6/3/2008 10:57'!
callWith: anArgument

	^ self callWithArguments: (Array with: anArgument)! !

!JSFunction methodsFor: '*jsextensions' stamp: 'sebastian.sastre 1/25/2010 11:49'!
callWithArguments: someArguments

	^ self call: 'call' withArguments: someArguments! !

!JSFunction methodsFor: '*jsextensions' stamp: 'sebastiansastre 1/7/2014 11:29'!
javascriptContentOn: aStream
	aStream nextPutAll: 'function('.
	self arguments do: [ :each | aStream nextPutAll: each ] separatedBy: [ aStream nextPut: $, ].
	aStream nextPutAll: '){'.
	statements isEmpty ifFalse:
			[ statements allButLast do:
					[ :each | 
					aStream
						javascript: each;
						nextPut: $; ].
		self return ifTrue: [ aStream nextPutAll: 'return ' ].
			aStream javascript: statements last ].
	aStream nextPut: $}! !

!JSAssign methodsFor: '*jsextensions' stamp: 'sebastian.sastre 1/17/2010 18:47'!
javascriptContentOn: aStream
	self name isString
		ifTrue:[aStream nextPutAll: self name]
		ifFalse:[aStream nextPutAll: self name asJavascript].

	aStream nextPut: $=.
	super javascriptContentOn: aStream! !

!Boolean methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 19:11'!
asJSObject
	"Answers the receiver as an instance of a javascript(able) object"
	^ self asString asJSObject! !

!String methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 19:17'!
asJSInfo
	^ JSLogger new info: self! !

!String methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 19:13'!
asJSLog
	^ JSLogger new log: self! !

!String methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 19:11'!
asJSObject
	^ JSObject new alias: self! !

!String methodsFor: '*jsextensions' stamp: 'sebastiansastre 1/5/2012 11:20'!
asJSString
	^ JSObject new alias: '"',self,'"'! !

!String methodsFor: '*jsextensions' stamp: 'sebastian.sastre 7/20/2009 19:17'!
asJSWarn
	^ JSLogger new warn: self! !

!String methodsFor: '*jsextensions' stamp: 'sebastiansastre 3/16/2014 09:25'!
js

	^ self asJSObject

	! !
